import { CommonsType } from 'tscommons-core';
import { __values, __decorate, __extends } from 'tslib';
import { RendererFactory2, ɵɵdefineInjectable, ɵɵinject, Injectable, Input, Component, EventEmitter, Output, NgModule } from '@angular/core';
import { ReplaySubject } from 'rxjs';
import { CommonsConfigService, NgxAngularCommonsAppModule } from 'ngx-angularcommons-app';
import { CommonsComponent, NgxAngularCommonsCoreModule } from 'ngx-angularcommons-core';
import { CommonModule } from '@angular/common';

var ECommonsThemeColor;
(function (ECommonsThemeColor) {
    ECommonsThemeColor["BLUE"] = "blue";
    ECommonsThemeColor["PURPLE"] = "purple";
    ECommonsThemeColor["DARKRED"] = "darkred";
    ECommonsThemeColor["MUTED"] = "muted";
    ECommonsThemeColor["NIGHT"] = "night";
    ECommonsThemeColor["MARINE"] = "marine";
    ECommonsThemeColor["HOTPINK"] = "hotpink";
})(ECommonsThemeColor || (ECommonsThemeColor = {}));
function toECommonsThemeColor(type) {
    switch (type) {
        case ECommonsThemeColor.BLUE.toString():
            return ECommonsThemeColor.BLUE;
        case ECommonsThemeColor.PURPLE.toString():
            return ECommonsThemeColor.PURPLE;
        case ECommonsThemeColor.DARKRED.toString():
            return ECommonsThemeColor.DARKRED;
        case ECommonsThemeColor.MUTED.toString():
            return ECommonsThemeColor.MUTED;
        case ECommonsThemeColor.NIGHT.toString():
            return ECommonsThemeColor.NIGHT;
        case ECommonsThemeColor.MARINE.toString():
            return ECommonsThemeColor.MARINE;
        case ECommonsThemeColor.HOTPINK.toString():
            return ECommonsThemeColor.HOTPINK;
    }
    return undefined;
}
function fromECommonsThemeColor(type) {
    switch (type) {
        case ECommonsThemeColor.BLUE:
            return ECommonsThemeColor.BLUE.toString();
        case ECommonsThemeColor.PURPLE:
            return ECommonsThemeColor.PURPLE.toString();
        case ECommonsThemeColor.DARKRED:
            return ECommonsThemeColor.DARKRED.toString();
        case ECommonsThemeColor.MUTED:
            return ECommonsThemeColor.MUTED.toString();
        case ECommonsThemeColor.NIGHT:
            return ECommonsThemeColor.NIGHT.toString();
        case ECommonsThemeColor.MARINE:
            return ECommonsThemeColor.MARINE.toString();
        case ECommonsThemeColor.HOTPINK:
            return ECommonsThemeColor.HOTPINK.toString();
    }
    throw new Error('Unknown ECommonsThemeColor');
}
function isECommonsThemeColor(test) {
    if (!CommonsType.isString(test))
        return false;
    return toECommonsThemeColor(test) !== undefined;
}
function keyToECommonsThemeColor(key) {
    switch (key) {
        case 'BLUE':
            return ECommonsThemeColor.BLUE;
        case 'PURPLE':
            return ECommonsThemeColor.PURPLE;
        case 'DARKRED':
            return ECommonsThemeColor.DARKRED;
        case 'MUTED':
            return ECommonsThemeColor.MUTED;
        case 'NIGHT':
            return ECommonsThemeColor.NIGHT;
        case 'MARINE':
            return ECommonsThemeColor.MARINE;
        case 'HOTPINK':
            return ECommonsThemeColor.HOTPINK;
    }
    throw new Error("Unable to obtain ECommonsThemeColor for key: " + key);
}
var ɵ0 = function (e) { return keyToECommonsThemeColor(e); };
var ECOMMONS_THEME_COLORS = Object.keys(ECommonsThemeColor)
    .map(ɵ0);

var ECommonsThemeContrast;
(function (ECommonsThemeContrast) {
    ECommonsThemeContrast["LIGHT"] = "light";
    ECommonsThemeContrast["DARK"] = "dark";
})(ECommonsThemeContrast || (ECommonsThemeContrast = {}));
function toECommonsThemeContrast(type) {
    switch (type) {
        case ECommonsThemeContrast.LIGHT.toString():
            return ECommonsThemeContrast.LIGHT;
        case ECommonsThemeContrast.DARK.toString():
            return ECommonsThemeContrast.DARK;
    }
    return undefined;
}
function fromECommonsThemeContrast(type) {
    switch (type) {
        case ECommonsThemeContrast.LIGHT:
            return ECommonsThemeContrast.LIGHT.toString();
        case ECommonsThemeContrast.DARK:
            return ECommonsThemeContrast.DARK.toString();
    }
    throw new Error('Unknown ECommonsThemeContrast');
}
function isECommonsThemeContrast(test) {
    if (!CommonsType.isString(test))
        return false;
    return toECommonsThemeContrast(test) !== undefined;
}
function keyToECommonsThemeContrast(key) {
    switch (key) {
        case 'LIGHT':
            return ECommonsThemeContrast.LIGHT;
        case 'DARK':
            return ECommonsThemeContrast.DARK;
    }
    throw new Error("Unable to obtain ECommonsThemeContrast for key: " + key);
}
var ɵ0$1 = function (e) { return keyToECommonsThemeContrast(e); };
var ECOMMONS_THEMES = Object.keys(ECommonsThemeContrast)
    .map(ɵ0$1);

var EMaterialDesignIcons;
(function (EMaterialDesignIcons) {
    EMaterialDesignIcons["MATERIALDESIGN"] = "material-design";
    EMaterialDesignIcons["MATERIALDESIGN3"] = "material-design-3";
    EMaterialDesignIcons["MDI"] = "mdi";
})(EMaterialDesignIcons || (EMaterialDesignIcons = {}));
function toEMaterialDesignIcons(type) {
    switch (type) {
        case EMaterialDesignIcons.MATERIALDESIGN.toString():
            return EMaterialDesignIcons.MATERIALDESIGN;
        case EMaterialDesignIcons.MATERIALDESIGN3.toString():
            return EMaterialDesignIcons.MATERIALDESIGN3;
        case EMaterialDesignIcons.MDI.toString():
            return EMaterialDesignIcons.MDI;
    }
    return undefined;
}
function fromEMaterialDesignIcons(type) {
    switch (type) {
        case EMaterialDesignIcons.MATERIALDESIGN:
            return EMaterialDesignIcons.MATERIALDESIGN.toString();
        case EMaterialDesignIcons.MATERIALDESIGN3:
            return EMaterialDesignIcons.MATERIALDESIGN3.toString();
        case EMaterialDesignIcons.MDI:
            return EMaterialDesignIcons.MDI.toString();
    }
    throw new Error('Unknown EMaterialDesignIcons');
}
function isEMaterialDesignIcons(test) {
    if (!CommonsType.isString(test))
        return false;
    return toEMaterialDesignIcons(test) !== undefined;
}
function keyToEMaterialDesignIcons(key) {
    switch (key) {
        case 'MATERIALDESIGN':
            return EMaterialDesignIcons.MATERIALDESIGN;
        case 'MATERIALDESIGN3':
            return EMaterialDesignIcons.MATERIALDESIGN3;
        case 'MDI':
            return EMaterialDesignIcons.MDI;
    }
    throw new Error("Unable to obtain EMaterialDesignIcons for key: " + key);
}
var ɵ0$2 = function (e) { return keyToEMaterialDesignIcons(e); };
var EMATERIAL_DESIGN_ICONSS = Object.keys(EMaterialDesignIcons)
    .map(ɵ0$2);

function isTCommonsThemeConfig(test) {
    if (!CommonsType.hasPropertyEnum(test, 'color', isECommonsThemeColor))
        return false;
    if (!CommonsType.hasPropertyEnum(test, 'contrast', isECommonsThemeContrast))
        return false;
    return true;
}

var CommonsThemeService = /** @class */ (function () {
    function CommonsThemeService(rendererFactory, configService) {
        this.configService = configService;
        this.onColorChanged = new ReplaySubject(1);
        this.onContrastChanged = new ReplaySubject(1);
        this.renderer = rendererFactory.createRenderer(null, null);
    }
    CommonsThemeService.prototype.loadConfigDefault = function () {
        var defaultTheme = this.configService.getObject('theme', 'default');
        if (!isTCommonsThemeConfig(defaultTheme))
            return false;
        this.setCurrentColor(defaultTheme.color);
        this.setCurrentContrast(defaultTheme.contrast);
        return true;
    };
    CommonsThemeService.prototype.getCurrentColor = function () {
        return this.currentColor;
    };
    CommonsThemeService.prototype.getCurrentContrast = function () {
        return this.currentContrast;
    };
    CommonsThemeService.prototype.setCurrentColor = function (color) {
        var e_1, _a;
        this.currentColor = color;
        this.renderer.addClass(document.body, "webappcommons-theme-" + color);
        try {
            for (var ECOMMONS_THEME_COLORS_1 = __values(ECOMMONS_THEME_COLORS), ECOMMONS_THEME_COLORS_1_1 = ECOMMONS_THEME_COLORS_1.next(); !ECOMMONS_THEME_COLORS_1_1.done; ECOMMONS_THEME_COLORS_1_1 = ECOMMONS_THEME_COLORS_1.next()) {
                var c = ECOMMONS_THEME_COLORS_1_1.value;
                if (c !== color) {
                    this.renderer.removeClass(document.body, "webappcommons-theme-" + c);
                }
            }
        }
        catch (e_1_1) { e_1 = { error: e_1_1 }; }
        finally {
            try {
                if (ECOMMONS_THEME_COLORS_1_1 && !ECOMMONS_THEME_COLORS_1_1.done && (_a = ECOMMONS_THEME_COLORS_1.return)) _a.call(ECOMMONS_THEME_COLORS_1);
            }
            finally { if (e_1) throw e_1.error; }
        }
        this.onColorChanged.next(color);
    };
    CommonsThemeService.prototype.setCurrentContrast = function (contrast) {
        this.currentContrast = contrast;
        switch (contrast) {
            case ECommonsThemeContrast.LIGHT:
                this.renderer.addClass(document.body, 'theme-light');
                this.renderer.removeClass(document.body, 'theme-dark');
                break;
            case ECommonsThemeContrast.DARK:
                this.renderer.addClass(document.body, 'theme-dark');
                this.renderer.removeClass(document.body, 'theme-light');
                break;
        }
        this.onContrastChanged.next(contrast);
    };
    CommonsThemeService.prototype.colorChangedObservable = function () {
        return this.onColorChanged;
    };
    CommonsThemeService.prototype.contrastChangedObservable = function () {
        return this.onContrastChanged;
    };
    CommonsThemeService.ctorParameters = function () { return [
        { type: RendererFactory2 },
        { type: CommonsConfigService }
    ]; };
    CommonsThemeService.ɵprov = ɵɵdefineInjectable({ factory: function CommonsThemeService_Factory() { return new CommonsThemeService(ɵɵinject(RendererFactory2), ɵɵinject(CommonsConfigService)); }, token: CommonsThemeService, providedIn: "root" });
    CommonsThemeService = __decorate([
        Injectable({
            providedIn: 'root'
        })
    ], CommonsThemeService);
    return CommonsThemeService;
}());

var CommonsPaneComponent = /** @class */ (function (_super) {
    __extends(CommonsPaneComponent, _super);
    function CommonsPaneComponent() {
        return _super.call(this) || this;
    }
    __decorate([
        Input()
    ], CommonsPaneComponent.prototype, "title", void 0);
    CommonsPaneComponent = __decorate([
        Component({
            selector: 'commons-pane',
            template: "<section>\n\t<h4 *ngIf=\"this.title\">{{this.title}}</h4>\n\t\n\t<ng-content></ng-content>\n</section>",
            styles: ["@charset 'utf8';section{display:block;box-sizing:border-box;padding:13px 20px;z-index:1000}h4{font-family:Roboto;font-weight:400;font-size:16px;margin:0 0 10px}:host-context(body.webappcommons-theme-blue.theme-light) h4{color:#999}:host-context(body.webappcommons-theme-blue.theme-dark) h4{color:#666}:host-context(body.webappcommons-theme-darkred.theme-light) h4{color:#6d6d6d}:host-context(body.webappcommons-theme-darkred.theme-dark) h4{color:#929292}:host-context(body.webappcommons-theme-hotpink.theme-light) h4{color:#999}:host-context(body.webappcommons-theme-hotpink.theme-dark) h4{color:#666}:host-context(body.webappcommons-theme-marine.theme-light) h4{color:#999}:host-context(body.webappcommons-theme-marine.theme-dark) h4{color:#666}:host-context(body.webappcommons-theme-muted.theme-light) h4{color:#999}:host-context(body.webappcommons-theme-muted.theme-dark) h4{color:#666}:host-context(body.webappcommons-theme-night.theme-light) h4{color:#999}:host-context(body.webappcommons-theme-night.theme-dark) h4{color:#666}:host-context(body.webappcommons-theme-patrolred.theme-light) h4{color:#999}:host-context(body.webappcommons-theme-patrolred.theme-dark) h4{color:#666}:host-context(body.webappcommons-theme-purple.theme-light) h4{color:#999}:host-context(body.webappcommons-theme-purple.theme-dark) h4{color:#666}:host.no-top-gap section{padding-top:0}:host.no-bottom-gap section{padding-bottom:0}:host.no-padding section{padding:0}:host-context(.no-padding) section{padding:0}:host.bigger-top-gap section{margin-top:15px}"]
        })
    ], CommonsPaneComponent);
    return CommonsPaneComponent;
}(CommonsComponent));

var CommonsButtonComponent = /** @class */ (function (_super) {
    __extends(CommonsButtonComponent, _super);
    function CommonsButtonComponent() {
        return _super.call(this) || this;
    }
    CommonsButtonComponent = __decorate([
        Component({
            selector: '[commons-button]',
            template: "<ng-content></ng-content>",
            styles: ["@charset 'utf8';:host{-webkit-appearance:none;-moz-appearance:none;appearance:none;font-family:Roboto;font-size:16px;line-height:16px;font-weight:500;text-transform:uppercase;box-sizing:border-box;padding:10px 16px;height:36px;min-width:64px;border:0;border-radius:4px;margin:4px;outline:0}:host.icon{width:44px;height:44px;border-radius:22px;padding:0;min-width:0;margin:2px}:host.icon.small{width:30px;height:30px;border-radius:15px}:host.icon.huge{width:100px;height:100px;border-radius:50px}:host-context(body.webappcommons-theme-blue.theme-light){background-color:#fff;color:#304ffe}:host-context(body.webappcommons-theme-blue.theme-light):active{background-color:#fff;color:#fff350}:host-context(body.webappcommons-theme-blue.theme-light).raised{background-color:#fff;color:#333}:host-context(body.webappcommons-theme-blue.theme-light).raised:active{background-color:#fff;color:#ffc107}:host-context(body.webappcommons-theme-blue.theme-light).filled{background-color:#304ffe;color:#fff}:host-context(body.webappcommons-theme-blue.theme-light).filled:active{background-color:#ffc107;color:#000}:host-context(body.webappcommons-theme-blue.theme-light).filled.secondary{background-color:#ffc107;color:#000}:host-context(body.webappcommons-theme-blue.theme-light).filled:disabled{background-color:#fff;color:#c2c2c2}:host-context(body.webappcommons-theme-blue.theme-light).filled,:host-context(body.webappcommons-theme-blue.theme-light).raised{box-shadow:.7px 1px 5px -.3px rgba(0,0,0,.5)}:host-context(body.webappcommons-theme-blue.theme-light).transparent{background-color:none}:host-context(body.webappcommons-theme-blue.theme-light):disabled{background-color:#fff;color:#c2c2c2;box-shadow:none}:host-context(body.webappcommons-theme-blue.theme-light):disabled.transparent{background-color:none}:host-context(body.webappcommons-theme-blue.theme-light).icon.filled:disabled{box-shadow:.7px 1px 5px -.3px rgba(0,0,0,.5)}:host-context(body.webappcommons-theme-blue.theme-dark){background-color:#000;color:#304ffe}:host-context(body.webappcommons-theme-blue.theme-dark):active{background-color:#000;color:#c79100}:host-context(body.webappcommons-theme-blue.theme-dark).raised{background-color:#000;color:#ccc}:host-context(body.webappcommons-theme-blue.theme-dark).raised:active{background-color:#000;color:#ffc107}:host-context(body.webappcommons-theme-blue.theme-dark).filled{background-color:#304ffe;color:#fff}:host-context(body.webappcommons-theme-blue.theme-dark).filled:active{background-color:#ffc107;color:#000}:host-context(body.webappcommons-theme-blue.theme-dark).filled.secondary{background-color:#ffc107;color:#000}:host-context(body.webappcommons-theme-blue.theme-dark).filled:disabled{background-color:#000;color:#c2c2c2}:host-context(body.webappcommons-theme-blue.theme-dark).filled,:host-context(body.webappcommons-theme-blue.theme-dark).raised{box-shadow:-.7px -1px 5px -.3px rgba(255,255,255,.5)}:host-context(body.webappcommons-theme-blue.theme-dark).transparent{background-color:none}:host-context(body.webappcommons-theme-blue.theme-dark):disabled{background-color:#000;color:#c2c2c2;box-shadow:none}:host-context(body.webappcommons-theme-blue.theme-dark):disabled.transparent{background-color:none}:host-context(body.webappcommons-theme-blue.theme-dark).icon.filled:disabled{box-shadow:-.7px -1px 5px -.3px rgba(255,255,255,.5)}:host-context(body.webappcommons-theme-darkred.theme-light){background-color:#212121;color:#d50000}:host-context(body.webappcommons-theme-darkred.theme-light):active{background-color:#212121;color:#ffff72}:host-context(body.webappcommons-theme-darkred.theme-light).raised{background-color:#212121;color:#b8b8b8}:host-context(body.webappcommons-theme-darkred.theme-light).raised:active{background-color:#212121;color:#ffeb3b}:host-context(body.webappcommons-theme-darkred.theme-light).filled{background-color:#d50000;color:#fff}:host-context(body.webappcommons-theme-darkred.theme-light).filled:active{background-color:#ffeb3b;color:#000}:host-context(body.webappcommons-theme-darkred.theme-light).filled.secondary{background-color:#ffeb3b;color:#000}:host-context(body.webappcommons-theme-darkred.theme-light).filled:disabled{background-color:#212121;color:#4e4e4e}:host-context(body.webappcommons-theme-darkred.theme-light).filled,:host-context(body.webappcommons-theme-darkred.theme-light).raised{box-shadow:.7px 1px 5px -.3px rgba(222,222,222,.5)}:host-context(body.webappcommons-theme-darkred.theme-light).transparent{background-color:none}:host-context(body.webappcommons-theme-darkred.theme-light):disabled{background-color:#212121;color:#4e4e4e;box-shadow:none}:host-context(body.webappcommons-theme-darkred.theme-light):disabled.transparent{background-color:none}:host-context(body.webappcommons-theme-darkred.theme-light).icon.filled:disabled{box-shadow:.7px 1px 5px -.3px rgba(222,222,222,.5)}:host-context(body.webappcommons-theme-darkred.theme-dark){background-color:#dedede;color:#d50000}:host-context(body.webappcommons-theme-darkred.theme-dark):active{background-color:#dedede;color:#c8b900}:host-context(body.webappcommons-theme-darkred.theme-dark).raised{background-color:#dedede;color:#474747}:host-context(body.webappcommons-theme-darkred.theme-dark).raised:active{background-color:#dedede;color:#ffeb3b}:host-context(body.webappcommons-theme-darkred.theme-dark).filled{background-color:#d50000;color:#fff}:host-context(body.webappcommons-theme-darkred.theme-dark).filled:active{background-color:#ffeb3b;color:#000}:host-context(body.webappcommons-theme-darkred.theme-dark).filled.secondary{background-color:#ffeb3b;color:#000}:host-context(body.webappcommons-theme-darkred.theme-dark).filled:disabled{background-color:#dedede;color:#4e4e4e}:host-context(body.webappcommons-theme-darkred.theme-dark).filled,:host-context(body.webappcommons-theme-darkred.theme-dark).raised{box-shadow:-.7px -1px 5px -.3px rgba(33,33,33,.5)}:host-context(body.webappcommons-theme-darkred.theme-dark).transparent{background-color:none}:host-context(body.webappcommons-theme-darkred.theme-dark):disabled{background-color:#dedede;color:#4e4e4e;box-shadow:none}:host-context(body.webappcommons-theme-darkred.theme-dark):disabled.transparent{background-color:none}:host-context(body.webappcommons-theme-darkred.theme-dark).icon.filled:disabled{box-shadow:-.7px -1px 5px -.3px rgba(33,33,33,.5)}:host-context(body.webappcommons-theme-hotpink.theme-light){background-color:#fff;color:#ef6ab3}:host-context(body.webappcommons-theme-hotpink.theme-light):active{background-color:#fff;color:#d0ffff}:host-context(body.webappcommons-theme-hotpink.theme-light).raised{background-color:#fff;color:#333}:host-context(body.webappcommons-theme-hotpink.theme-light).raised:active{background-color:#fff;color:#9debef}:host-context(body.webappcommons-theme-hotpink.theme-light).filled{background-color:#ef6ab3;color:#fff}:host-context(body.webappcommons-theme-hotpink.theme-light).filled:active{background-color:#9debef;color:#000}:host-context(body.webappcommons-theme-hotpink.theme-light).filled.secondary{background-color:#9debef;color:#000}:host-context(body.webappcommons-theme-hotpink.theme-light).filled:disabled{background-color:#fff;color:#c2c2c2}:host-context(body.webappcommons-theme-hotpink.theme-light).filled,:host-context(body.webappcommons-theme-hotpink.theme-light).raised{box-shadow:.7px 1px 5px -.3px rgba(0,0,0,.5)}:host-context(body.webappcommons-theme-hotpink.theme-light).transparent{background-color:none}:host-context(body.webappcommons-theme-hotpink.theme-light):disabled{background-color:#fff;color:#c2c2c2;box-shadow:none}:host-context(body.webappcommons-theme-hotpink.theme-light):disabled.transparent{background-color:none}:host-context(body.webappcommons-theme-hotpink.theme-light).icon.filled:disabled{box-shadow:.7px 1px 5px -.3px rgba(0,0,0,.5)}:host-context(body.webappcommons-theme-hotpink.theme-dark){background-color:#000;color:#ef6ab3}:host-context(body.webappcommons-theme-hotpink.theme-dark):active{background-color:#000;color:#6bb8bd}:host-context(body.webappcommons-theme-hotpink.theme-dark).raised{background-color:#000;color:#ccc}:host-context(body.webappcommons-theme-hotpink.theme-dark).raised:active{background-color:#000;color:#9debef}:host-context(body.webappcommons-theme-hotpink.theme-dark).filled{background-color:#ef6ab3;color:#fff}:host-context(body.webappcommons-theme-hotpink.theme-dark).filled:active{background-color:#9debef;color:#000}:host-context(body.webappcommons-theme-hotpink.theme-dark).filled.secondary{background-color:#9debef;color:#000}:host-context(body.webappcommons-theme-hotpink.theme-dark).filled:disabled{background-color:#000;color:#c2c2c2}:host-context(body.webappcommons-theme-hotpink.theme-dark).filled,:host-context(body.webappcommons-theme-hotpink.theme-dark).raised{box-shadow:-.7px -1px 5px -.3px rgba(255,255,255,.5)}:host-context(body.webappcommons-theme-hotpink.theme-dark).transparent{background-color:none}:host-context(body.webappcommons-theme-hotpink.theme-dark):disabled{background-color:#000;color:#c2c2c2;box-shadow:none}:host-context(body.webappcommons-theme-hotpink.theme-dark):disabled.transparent{background-color:none}:host-context(body.webappcommons-theme-hotpink.theme-dark).icon.filled:disabled{box-shadow:-.7px -1px 5px -.3px rgba(255,255,255,.5)}:host-context(body.webappcommons-theme-marine.theme-light){background-color:#fff;color:#2994ae}:host-context(body.webappcommons-theme-marine.theme-light):active{background-color:#fff;color:#cbffff}:host-context(body.webappcommons-theme-marine.theme-light).raised{background-color:#fff;color:#333}:host-context(body.webappcommons-theme-marine.theme-light).raised:active{background-color:#fff;color:#99d1dd}:host-context(body.webappcommons-theme-marine.theme-light).filled{background-color:#2994ae;color:#fff}:host-context(body.webappcommons-theme-marine.theme-light).filled:active{background-color:#99d1dd;color:#000}:host-context(body.webappcommons-theme-marine.theme-light).filled.secondary{background-color:#99d1dd;color:#000}:host-context(body.webappcommons-theme-marine.theme-light).filled:disabled{background-color:#fff;color:#c2c2c2}:host-context(body.webappcommons-theme-marine.theme-light).filled,:host-context(body.webappcommons-theme-marine.theme-light).raised{box-shadow:.7px 1px 5px -.3px rgba(0,0,0,.5)}:host-context(body.webappcommons-theme-marine.theme-light).transparent{background-color:none}:host-context(body.webappcommons-theme-marine.theme-light):disabled{background-color:#fff;color:#c2c2c2;box-shadow:none}:host-context(body.webappcommons-theme-marine.theme-light):disabled.transparent{background-color:none}:host-context(body.webappcommons-theme-marine.theme-light).icon.filled:disabled{box-shadow:.7px 1px 5px -.3px rgba(0,0,0,.5)}:host-context(body.webappcommons-theme-marine.theme-dark){background-color:#000;color:#2994ae}:host-context(body.webappcommons-theme-marine.theme-dark):active{background-color:#000;color:#69a0ab}:host-context(body.webappcommons-theme-marine.theme-dark).raised{background-color:#000;color:#ccc}:host-context(body.webappcommons-theme-marine.theme-dark).raised:active{background-color:#000;color:#99d1dd}:host-context(body.webappcommons-theme-marine.theme-dark).filled{background-color:#2994ae;color:#fff}:host-context(body.webappcommons-theme-marine.theme-dark).filled:active{background-color:#99d1dd;color:#000}:host-context(body.webappcommons-theme-marine.theme-dark).filled.secondary{background-color:#99d1dd;color:#000}:host-context(body.webappcommons-theme-marine.theme-dark).filled:disabled{background-color:#000;color:#c2c2c2}:host-context(body.webappcommons-theme-marine.theme-dark).filled,:host-context(body.webappcommons-theme-marine.theme-dark).raised{box-shadow:-.7px -1px 5px -.3px rgba(255,255,255,.5)}:host-context(body.webappcommons-theme-marine.theme-dark).transparent{background-color:none}:host-context(body.webappcommons-theme-marine.theme-dark):disabled{background-color:#000;color:#c2c2c2;box-shadow:none}:host-context(body.webappcommons-theme-marine.theme-dark):disabled.transparent{background-color:none}:host-context(body.webappcommons-theme-marine.theme-dark).icon.filled:disabled{box-shadow:-.7px -1px 5px -.3px rgba(255,255,255,.5)}:host-context(body.webappcommons-theme-muted.theme-light){background-color:#fff;color:#54637a}:host-context(body.webappcommons-theme-muted.theme-light):active{background-color:#fff;color:#ffff6b}:host-context(body.webappcommons-theme-muted.theme-light).raised{background-color:#fff;color:#333}:host-context(body.webappcommons-theme-muted.theme-light).raised:active{background-color:#fff;color:#fdd835}:host-context(body.webappcommons-theme-muted.theme-light).filled{background-color:#54637a;color:#fff}:host-context(body.webappcommons-theme-muted.theme-light).filled:active{background-color:#fdd835;color:#000}:host-context(body.webappcommons-theme-muted.theme-light).filled.secondary{background-color:#fdd835;color:#000}:host-context(body.webappcommons-theme-muted.theme-light).filled:disabled{background-color:#fff;color:#c2c2c2}:host-context(body.webappcommons-theme-muted.theme-light).filled,:host-context(body.webappcommons-theme-muted.theme-light).raised{box-shadow:.7px 1px 5px -.3px rgba(0,0,0,.5)}:host-context(body.webappcommons-theme-muted.theme-light).transparent{background-color:none}:host-context(body.webappcommons-theme-muted.theme-light):disabled{background-color:#fff;color:#c2c2c2;box-shadow:none}:host-context(body.webappcommons-theme-muted.theme-light):disabled.transparent{background-color:none}:host-context(body.webappcommons-theme-muted.theme-light).icon.filled:disabled{box-shadow:.7px 1px 5px -.3px rgba(0,0,0,.5)}:host-context(body.webappcommons-theme-muted.theme-dark){background-color:#000;color:#54637a}:host-context(body.webappcommons-theme-muted.theme-dark):active{background-color:#000;color:#c6a700}:host-context(body.webappcommons-theme-muted.theme-dark).raised{background-color:#000;color:#ccc}:host-context(body.webappcommons-theme-muted.theme-dark).raised:active{background-color:#000;color:#fdd835}:host-context(body.webappcommons-theme-muted.theme-dark).filled{background-color:#54637a;color:#fff}:host-context(body.webappcommons-theme-muted.theme-dark).filled:active{background-color:#fdd835;color:#000}:host-context(body.webappcommons-theme-muted.theme-dark).filled.secondary{background-color:#fdd835;color:#000}:host-context(body.webappcommons-theme-muted.theme-dark).filled:disabled{background-color:#000;color:#c2c2c2}:host-context(body.webappcommons-theme-muted.theme-dark).filled,:host-context(body.webappcommons-theme-muted.theme-dark).raised{box-shadow:-.7px -1px 5px -.3px rgba(255,255,255,.5)}:host-context(body.webappcommons-theme-muted.theme-dark).transparent{background-color:none}:host-context(body.webappcommons-theme-muted.theme-dark):disabled{background-color:#000;color:#c2c2c2;box-shadow:none}:host-context(body.webappcommons-theme-muted.theme-dark):disabled.transparent{background-color:none}:host-context(body.webappcommons-theme-muted.theme-dark).icon.filled:disabled{box-shadow:-.7px -1px 5px -.3px rgba(255,255,255,.5)}:host-context(body.webappcommons-theme-night.theme-light){background-color:#fff;color:#104e7c}:host-context(body.webappcommons-theme-night.theme-light):active{background-color:#fff;color:#e8d9bf}:host-context(body.webappcommons-theme-night.theme-light).raised{background-color:#fff;color:#333}:host-context(body.webappcommons-theme-night.theme-light).raised:active{background-color:#fff;color:#e7c385}:host-context(body.webappcommons-theme-night.theme-light).filled{background-color:#104e7c;color:#fff}:host-context(body.webappcommons-theme-night.theme-light).filled:active{background-color:#e7c385;color:#000}:host-context(body.webappcommons-theme-night.theme-light).filled.secondary{background-color:#e7c385;color:#000}:host-context(body.webappcommons-theme-night.theme-light).filled:disabled{background-color:#fff;color:#c2c2c2}:host-context(body.webappcommons-theme-night.theme-light).filled,:host-context(body.webappcommons-theme-night.theme-light).raised{box-shadow:.7px 1px 5px -.3px rgba(0,0,0,.5)}:host-context(body.webappcommons-theme-night.theme-light).transparent{background-color:none}:host-context(body.webappcommons-theme-night.theme-light):disabled{background-color:#fff;color:#c2c2c2;box-shadow:none}:host-context(body.webappcommons-theme-night.theme-light):disabled.transparent{background-color:none}:host-context(body.webappcommons-theme-night.theme-light).icon.filled:disabled{box-shadow:.7px 1px 5px -.3px rgba(0,0,0,.5)}:host-context(body.webappcommons-theme-night.theme-dark){background-color:#000;color:#104e7c}:host-context(body.webappcommons-theme-night.theme-dark):active{background-color:#000;color:#948467}:host-context(body.webappcommons-theme-night.theme-dark).raised{background-color:#000;color:#ccc}:host-context(body.webappcommons-theme-night.theme-dark).raised:active{background-color:#000;color:#e7c385}:host-context(body.webappcommons-theme-night.theme-dark).filled{background-color:#104e7c;color:#fff}:host-context(body.webappcommons-theme-night.theme-dark).filled:active{background-color:#e7c385;color:#000}:host-context(body.webappcommons-theme-night.theme-dark).filled.secondary{background-color:#e7c385;color:#000}:host-context(body.webappcommons-theme-night.theme-dark).filled:disabled{background-color:#000;color:#c2c2c2}:host-context(body.webappcommons-theme-night.theme-dark).filled,:host-context(body.webappcommons-theme-night.theme-dark).raised{box-shadow:-.7px -1px 5px -.3px rgba(255,255,255,.5)}:host-context(body.webappcommons-theme-night.theme-dark).transparent{background-color:none}:host-context(body.webappcommons-theme-night.theme-dark):disabled{background-color:#000;color:#c2c2c2;box-shadow:none}:host-context(body.webappcommons-theme-night.theme-dark):disabled.transparent{background-color:none}:host-context(body.webappcommons-theme-night.theme-dark).icon.filled:disabled{box-shadow:-.7px -1px 5px -.3px rgba(255,255,255,.5)}:host-context(body.webappcommons-theme-patrolred.theme-light){background-color:#fff;color:#d6001c}:host-context(body.webappcommons-theme-patrolred.theme-light):active{background-color:#fff;color:#c1d5e0}:host-context(body.webappcommons-theme-patrolred.theme-light).raised{background-color:#fff;color:#333}:host-context(body.webappcommons-theme-patrolred.theme-light).raised:active{background-color:#fff;color:#90a4ae}:host-context(body.webappcommons-theme-patrolred.theme-light).filled{background-color:#d6001c;color:#fff}:host-context(body.webappcommons-theme-patrolred.theme-light).filled:active{background-color:#90a4ae;color:#fff}:host-context(body.webappcommons-theme-patrolred.theme-light).filled.secondary{background-color:#90a4ae;color:#fff}:host-context(body.webappcommons-theme-patrolred.theme-light).filled:disabled{background-color:#fff;color:#c2c2c2}:host-context(body.webappcommons-theme-patrolred.theme-light).filled,:host-context(body.webappcommons-theme-patrolred.theme-light).raised{box-shadow:.7px 1px 5px -.3px rgba(0,0,0,.5)}:host-context(body.webappcommons-theme-patrolred.theme-light).transparent{background-color:none}:host-context(body.webappcommons-theme-patrolred.theme-light):disabled{background-color:#fff;color:#c2c2c2;box-shadow:none}:host-context(body.webappcommons-theme-patrolred.theme-light):disabled.transparent{background-color:none}:host-context(body.webappcommons-theme-patrolred.theme-light).icon.filled:disabled{box-shadow:.7px 1px 5px -.3px rgba(0,0,0,.5)}:host-context(body.webappcommons-theme-patrolred.theme-dark){background-color:#000;color:#d6001c}:host-context(body.webappcommons-theme-patrolred.theme-dark):active{background-color:#000;color:#62757f}:host-context(body.webappcommons-theme-patrolred.theme-dark).raised{background-color:#000;color:#ccc}:host-context(body.webappcommons-theme-patrolred.theme-dark).raised:active{background-color:#000;color:#90a4ae}:host-context(body.webappcommons-theme-patrolred.theme-dark).filled{background-color:#d6001c;color:#fff}:host-context(body.webappcommons-theme-patrolred.theme-dark).filled:active{background-color:#90a4ae;color:#fff}:host-context(body.webappcommons-theme-patrolred.theme-dark).filled.secondary{background-color:#90a4ae;color:#fff}:host-context(body.webappcommons-theme-patrolred.theme-dark).filled:disabled{background-color:#000;color:#c2c2c2}:host-context(body.webappcommons-theme-patrolred.theme-dark).filled,:host-context(body.webappcommons-theme-patrolred.theme-dark).raised{box-shadow:-.7px -1px 5px -.3px rgba(255,255,255,.5)}:host-context(body.webappcommons-theme-patrolred.theme-dark).transparent{background-color:none}:host-context(body.webappcommons-theme-patrolred.theme-dark):disabled{background-color:#000;color:#c2c2c2;box-shadow:none}:host-context(body.webappcommons-theme-patrolred.theme-dark):disabled.transparent{background-color:none}:host-context(body.webappcommons-theme-patrolred.theme-dark).icon.filled:disabled{box-shadow:-.7px -1px 5px -.3px rgba(255,255,255,.5)}:host-context(body.webappcommons-theme-purple.theme-light){background-color:#fff;color:#609}:host-context(body.webappcommons-theme-purple.theme-light):active{background-color:#fff;color:#fff350}:host-context(body.webappcommons-theme-purple.theme-light).raised{background-color:#fff;color:#333}:host-context(body.webappcommons-theme-purple.theme-light).raised:active{background-color:#fff;color:#fc3}:host-context(body.webappcommons-theme-purple.theme-light).filled{background-color:#609;color:#fff}:host-context(body.webappcommons-theme-purple.theme-light).filled:active{background-color:#fc3;color:#000}:host-context(body.webappcommons-theme-purple.theme-light).filled.secondary{background-color:#fc3;color:#000}:host-context(body.webappcommons-theme-purple.theme-light).filled:disabled{background-color:#fff;color:#c2c2c2}:host-context(body.webappcommons-theme-purple.theme-light).filled,:host-context(body.webappcommons-theme-purple.theme-light).raised{box-shadow:.7px 1px 5px -.3px rgba(0,0,0,.5)}:host-context(body.webappcommons-theme-purple.theme-light).transparent{background-color:none}:host-context(body.webappcommons-theme-purple.theme-light):disabled{background-color:#fff;color:#c2c2c2;box-shadow:none}:host-context(body.webappcommons-theme-purple.theme-light):disabled.transparent{background-color:none}:host-context(body.webappcommons-theme-purple.theme-light).icon.filled:disabled{box-shadow:.7px 1px 5px -.3px rgba(0,0,0,.5)}:host-context(body.webappcommons-theme-purple.theme-dark){background-color:#000;color:#609}:host-context(body.webappcommons-theme-purple.theme-dark):active{background-color:#000;color:#c79100}:host-context(body.webappcommons-theme-purple.theme-dark).raised{background-color:#000;color:#ccc}:host-context(body.webappcommons-theme-purple.theme-dark).raised:active{background-color:#000;color:#fc3}:host-context(body.webappcommons-theme-purple.theme-dark).filled{background-color:#609;color:#fff}:host-context(body.webappcommons-theme-purple.theme-dark).filled:active{background-color:#fc3;color:#000}:host-context(body.webappcommons-theme-purple.theme-dark).filled.secondary{background-color:#fc3;color:#000}:host-context(body.webappcommons-theme-purple.theme-dark).filled:disabled{background-color:#000;color:#c2c2c2}:host-context(body.webappcommons-theme-purple.theme-dark).filled,:host-context(body.webappcommons-theme-purple.theme-dark).raised{box-shadow:-.7px -1px 5px -.3px rgba(255,255,255,.5)}:host-context(body.webappcommons-theme-purple.theme-dark).transparent{background-color:none}:host-context(body.webappcommons-theme-purple.theme-dark):disabled{background-color:#000;color:#c2c2c2;box-shadow:none}:host-context(body.webappcommons-theme-purple.theme-dark):disabled.transparent{background-color:none}:host-context(body.webappcommons-theme-purple.theme-dark).icon.filled:disabled{box-shadow:-.7px -1px 5px -.3px rgba(255,255,255,.5)}"]
        })
    ], CommonsButtonComponent);
    return CommonsButtonComponent;
}(CommonsComponent));

var CommonsButtonBarComponent = /** @class */ (function (_super) {
    __extends(CommonsButtonBarComponent, _super);
    function CommonsButtonBarComponent() {
        return _super.call(this) || this;
    }
    CommonsButtonBarComponent = __decorate([
        Component({
            selector: 'commons-button-bar',
            template: "<aside><ng-content></ng-content></aside>\n",
            styles: ["@charset 'utf8';aside{display:flex;flex-wrap:wrap;align-items:center;justify-content:flex-start;gap:8px}:host.right aside{justify-content:flex-end}:host.center aside{justify-content:center}"]
        })
    ], CommonsButtonBarComponent);
    return CommonsButtonBarComponent;
}(CommonsComponent));

var CommonsInfoLineComponent = /** @class */ (function (_super) {
    __extends(CommonsInfoLineComponent, _super);
    function CommonsInfoLineComponent() {
        var _this = _super.call(this) || this;
        _this.onClose = new EventEmitter();
        return _this;
    }
    __decorate([
        Input()
    ], CommonsInfoLineComponent.prototype, "allowClose", void 0);
    __decorate([
        Output()
    ], CommonsInfoLineComponent.prototype, "onClose", void 0);
    CommonsInfoLineComponent = __decorate([
        Component({
            selector: 'commons-info-line',
            template: "<aside>\n\t<i class=\"material-icons info\">info</i>\n\t<i class=\"material-icons error\">warning</i>\n\t<i class=\"material-icons notification\">priority_high</i>\n\t<i class=\"material-icons success\">check</i>\n\t<i class=\"material-icons help\">lightbulb_outline</i>\n\t<i class=\"material-icons close\" *ngIf=\"this.allowClose\"\n\t\t\t(click)=\"this.onClose.emit();\"\n\t>close</i>\n\t<ng-content></ng-content>\n</aside>\n",
            styles: ["@charset 'utf8';:host i.error,:host i.help,:host i.info,:host i.notification,:host i.subtle,:host i.success{display:none}:host[info] i.info{display:inline-block}:host[error] i.error{display:inline-block}:host[notification] i.notification{display:inline-block}:host[success] i.success{display:inline-block}:host[help] i.help{display:inline-block}:host[subtle] i.info{display:inline-block}aside{position:relative;top:0;left:0;display:block;width:100%;height:50px;box-sizing:border-box;padding-top:18px;font-family:Roboto;font-size:14px;font-weight:500;line-height:14px;white-space:nowrap;overflow:hidden;text-overflow:ellipsis;text-align:left;padding-left:1em;padding-right:1em;margin:20px 0 10px}:host-context(body.webappcommons-theme-blue.theme-light) aside{background-color:#fff;color:#000}:host-context(body.webappcommons-theme-blue.theme-dark) aside{background-color:#000;color:#fff}:host-context(body.webappcommons-theme-darkred.theme-light) aside{background-color:#212121;color:#dedede}:host-context(body.webappcommons-theme-darkred.theme-dark) aside{background-color:#dedede;color:#212121}:host-context(body.webappcommons-theme-hotpink.theme-light) aside{background-color:#fff;color:#000}:host-context(body.webappcommons-theme-hotpink.theme-dark) aside{background-color:#000;color:#fff}:host-context(body.webappcommons-theme-marine.theme-light) aside{background-color:#fff;color:#000}:host-context(body.webappcommons-theme-marine.theme-dark) aside{background-color:#000;color:#fff}:host-context(body.webappcommons-theme-muted.theme-light) aside{background-color:#fff;color:#000}:host-context(body.webappcommons-theme-muted.theme-dark) aside{background-color:#000;color:#fff}:host-context(body.webappcommons-theme-night.theme-light) aside{background-color:#fff;color:#000}:host-context(body.webappcommons-theme-night.theme-dark) aside{background-color:#000;color:#fff}:host-context(body.webappcommons-theme-patrolred.theme-light) aside{background-color:#fff;color:#000}:host-context(body.webappcommons-theme-patrolred.theme-dark) aside{background-color:#000;color:#fff}:host-context(body.webappcommons-theme-purple.theme-light) aside{background-color:#fff;color:#000}:host-context(body.webappcommons-theme-purple.theme-dark) aside{background-color:#000;color:#fff}aside i.error,aside i.help,aside i.info,aside i.notification,aside i.subtle,aside i.success{float:left;font-size:inherit;margin-right:1em;color:inherit}aside i.close{position:absolute;right:1em;top:18px;font-size:inherit;color:inherit}:host.compact aside{margin:0}:host-context(body.webappcommons-theme-blue)[info] aside{background-color:#304ffe;color:#fff}:host-context(body.webappcommons-theme-blue)[error] aside{background-color:#e63322;color:#fff}:host-context(body.webappcommons-theme-blue)[notification] aside{background-color:#ffc107;color:#000}:host-context(body.webappcommons-theme-blue)[success] aside{background-color:#8bc34a;color:#000}:host-context(body.webappcommons-theme-blue)[help] aside{background-color:#fffbcb;color:#000}:host-context(body.webappcommons-theme-blue.theme-light)[subtle] aside{background-color:#999;color:#333}:host-context(body.webappcommons-theme-blue.theme-dark)[subtle] aside{background-color:#666;color:#000}:host-context(body.webappcommons-theme-blue.theme-light)[subtler] aside{background-color:#bfbfbf;color:#333}:host-context(body.webappcommons-theme-blue.theme-dark)[subtler] aside{background-color:#404040;color:#000}:host-context(body.webappcommons-theme-blue.theme-light)[subtlest] aside{background-color:#f2f2f2;color:#333}:host-context(body.webappcommons-theme-blue.theme-dark)[subtlest] aside{background-color:#0d0d0d;color:#000}:host-context(body.webappcommons-theme-darkred)[info] aside{background-color:#d50000;color:#fff}:host-context(body.webappcommons-theme-darkred)[error] aside{background-color:#e63322;color:#fff}:host-context(body.webappcommons-theme-darkred)[notification] aside{background-color:#ffeb3b;color:#000}:host-context(body.webappcommons-theme-darkred)[success] aside{background-color:#8bc34a;color:#000}:host-context(body.webappcommons-theme-darkred)[help] aside{background-color:#646439;color:#000}:host-context(body.webappcommons-theme-darkred.theme-light)[subtle] aside{background-color:#6d6d6d;color:#b8b8b8}:host-context(body.webappcommons-theme-darkred.theme-dark)[subtle] aside{background-color:#929292;color:#dedede}:host-context(body.webappcommons-theme-darkred.theme-light)[subtler] aside{background-color:#505050;color:#b8b8b8}:host-context(body.webappcommons-theme-darkred.theme-dark)[subtler] aside{background-color:#afafaf;color:#dedede}:host-context(body.webappcommons-theme-darkred.theme-light)[subtlest] aside{background-color:#2a2a2a;color:#b8b8b8}:host-context(body.webappcommons-theme-darkred.theme-dark)[subtlest] aside{background-color:#d5d5d5;color:#dedede}:host-context(body.webappcommons-theme-hotpink)[info] aside{background-color:#ef6ab3;color:#fff}:host-context(body.webappcommons-theme-hotpink)[error] aside{background-color:#e63322;color:#fff}:host-context(body.webappcommons-theme-hotpink)[notification] aside{background-color:#9debef;color:#000}:host-context(body.webappcommons-theme-hotpink)[success] aside{background-color:#8bc34a;color:#000}:host-context(body.webappcommons-theme-hotpink)[help] aside{background-color:#f1ffff;color:#000}:host-context(body.webappcommons-theme-hotpink.theme-light)[subtle] aside{background-color:#999;color:#333}:host-context(body.webappcommons-theme-hotpink.theme-dark)[subtle] aside{background-color:#666;color:#000}:host-context(body.webappcommons-theme-hotpink.theme-light)[subtler] aside{background-color:#bfbfbf;color:#333}:host-context(body.webappcommons-theme-hotpink.theme-dark)[subtler] aside{background-color:#404040;color:#000}:host-context(body.webappcommons-theme-hotpink.theme-light)[subtlest] aside{background-color:#f2f2f2;color:#333}:host-context(body.webappcommons-theme-hotpink.theme-dark)[subtlest] aside{background-color:#0d0d0d;color:#000}:host-context(body.webappcommons-theme-marine)[info] aside{background-color:#2994ae;color:#fff}:host-context(body.webappcommons-theme-marine)[error] aside{background-color:#e63322;color:#fff}:host-context(body.webappcommons-theme-marine)[notification] aside{background-color:#99d1dd;color:#000}:host-context(body.webappcommons-theme-marine)[success] aside{background-color:#8bc34a;color:#000}:host-context(body.webappcommons-theme-marine)[help] aside{background-color:#efffff;color:#000}:host-context(body.webappcommons-theme-marine.theme-light)[subtle] aside{background-color:#999;color:#333}:host-context(body.webappcommons-theme-marine.theme-dark)[subtle] aside{background-color:#666;color:#000}:host-context(body.webappcommons-theme-marine.theme-light)[subtler] aside{background-color:#bfbfbf;color:#333}:host-context(body.webappcommons-theme-marine.theme-dark)[subtler] aside{background-color:#404040;color:#000}:host-context(body.webappcommons-theme-marine.theme-light)[subtlest] aside{background-color:#f2f2f2;color:#333}:host-context(body.webappcommons-theme-marine.theme-dark)[subtlest] aside{background-color:#0d0d0d;color:#000}:host-context(body.webappcommons-theme-muted)[info] aside{background-color:#54637a;color:#fff}:host-context(body.webappcommons-theme-muted)[error] aside{background-color:#e63322;color:#fff}:host-context(body.webappcommons-theme-muted)[notification] aside{background-color:#fdd835;color:#000}:host-context(body.webappcommons-theme-muted)[success] aside{background-color:#8bc34a;color:#000}:host-context(body.webappcommons-theme-muted)[help] aside{background-color:#ffffd3;color:#000}:host-context(body.webappcommons-theme-muted.theme-light)[subtle] aside{background-color:#999;color:#333}:host-context(body.webappcommons-theme-muted.theme-dark)[subtle] aside{background-color:#666;color:#000}:host-context(body.webappcommons-theme-muted.theme-light)[subtler] aside{background-color:#bfbfbf;color:#333}:host-context(body.webappcommons-theme-muted.theme-dark)[subtler] aside{background-color:#404040;color:#000}:host-context(body.webappcommons-theme-muted.theme-light)[subtlest] aside{background-color:#f2f2f2;color:#333}:host-context(body.webappcommons-theme-muted.theme-dark)[subtlest] aside{background-color:#0d0d0d;color:#000}:host-context(body.webappcommons-theme-night)[info] aside{background-color:#104e7c;color:#fff}:host-context(body.webappcommons-theme-night)[error] aside{background-color:#e63322;color:#fff}:host-context(body.webappcommons-theme-night)[notification] aside{background-color:#e7c385;color:#000}:host-context(body.webappcommons-theme-night)[success] aside{background-color:#8bc34a;color:#000}:host-context(body.webappcommons-theme-night)[help] aside{background-color:#f8f4ec;color:#000}:host-context(body.webappcommons-theme-night.theme-light)[subtle] aside{background-color:#999;color:#333}:host-context(body.webappcommons-theme-night.theme-dark)[subtle] aside{background-color:#666;color:#000}:host-context(body.webappcommons-theme-night.theme-light)[subtler] aside{background-color:#bfbfbf;color:#333}:host-context(body.webappcommons-theme-night.theme-dark)[subtler] aside{background-color:#404040;color:#000}:host-context(body.webappcommons-theme-night.theme-light)[subtlest] aside{background-color:#f2f2f2;color:#333}:host-context(body.webappcommons-theme-night.theme-dark)[subtlest] aside{background-color:#0d0d0d;color:#000}:host-context(body.webappcommons-theme-patrolred)[info] aside{background-color:#d6001c;color:#fff}:host-context(body.webappcommons-theme-patrolred)[error] aside{background-color:#e63322;color:#fff}:host-context(body.webappcommons-theme-patrolred)[notification] aside{background-color:#90a4ae;color:#fff}:host-context(body.webappcommons-theme-patrolred)[success] aside{background-color:#8bc34a;color:#000}:host-context(body.webappcommons-theme-patrolred)[help] aside{background-color:#ecf2f6;color:#fff}:host-context(body.webappcommons-theme-patrolred.theme-light)[subtle] aside{background-color:#999;color:#333}:host-context(body.webappcommons-theme-patrolred.theme-dark)[subtle] aside{background-color:#666;color:#000}:host-context(body.webappcommons-theme-patrolred.theme-light)[subtler] aside{background-color:#bfbfbf;color:#333}:host-context(body.webappcommons-theme-patrolred.theme-dark)[subtler] aside{background-color:#404040;color:#000}:host-context(body.webappcommons-theme-patrolred.theme-light)[subtlest] aside{background-color:#f2f2f2;color:#333}:host-context(body.webappcommons-theme-patrolred.theme-dark)[subtlest] aside{background-color:#0d0d0d;color:#000}:host-context(body.webappcommons-theme-purple)[info] aside{background-color:#609;color:#fff}:host-context(body.webappcommons-theme-purple)[error] aside{background-color:#e63322;color:#fff}:host-context(body.webappcommons-theme-purple)[notification] aside{background-color:#fc3;color:#000}:host-context(body.webappcommons-theme-purple)[success] aside{background-color:#8bc34a;color:#000}:host-context(body.webappcommons-theme-purple)[help] aside{background-color:#fffbcb;color:#000}:host-context(body.webappcommons-theme-purple.theme-light)[subtle] aside{background-color:#999;color:#333}:host-context(body.webappcommons-theme-purple.theme-dark)[subtle] aside{background-color:#666;color:#000}:host-context(body.webappcommons-theme-purple.theme-light)[subtler] aside{background-color:#bfbfbf;color:#333}:host-context(body.webappcommons-theme-purple.theme-dark)[subtler] aside{background-color:#404040;color:#000}:host-context(body.webappcommons-theme-purple.theme-light)[subtlest] aside{background-color:#f2f2f2;color:#333}:host-context(body.webappcommons-theme-purple.theme-dark)[subtlest] aside{background-color:#0d0d0d;color:#000}"]
        })
    ], CommonsInfoLineComponent);
    return CommonsInfoLineComponent;
}(CommonsComponent));

var CommonsDetailsComponent = /** @class */ (function (_super) {
    __extends(CommonsDetailsComponent, _super);
    function CommonsDetailsComponent() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    CommonsDetailsComponent = __decorate([
        Component({
            selector: '[commons-details]',
            template: "<ng-content></ng-content>",
            styles: ["@charset 'utf8';:host{list-style:none;margin:0;padding:0}"]
        })
    ], CommonsDetailsComponent);
    return CommonsDetailsComponent;
}(CommonsComponent));

var CommonsDetailLabelComponent = /** @class */ (function (_super) {
    __extends(CommonsDetailLabelComponent, _super);
    function CommonsDetailLabelComponent() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    __decorate([
        Input()
    ], CommonsDetailLabelComponent.prototype, "icon", void 0);
    CommonsDetailLabelComponent = __decorate([
        Component({
            selector: '[commons-detail-label]',
            template: "<label><i class=\"material-icons\" *ngIf=\"this.icon\">{{this.icon}}</i><ng-content></ng-content></label>",
            styles: ["@charset 'utf8';:host{display:block;margin:0;padding:0;float:left;box-sizing:border-box;height:40px;width:180px}label{position:relative;top:0;box-sizing:border-box;height:40px;width:180px;overflow:hidden;text-overflow:ellipsis;white-space:nowrap;float:left;font-family:Roboto;font-size:16px;font-weight:400;line-height:16px;padding-top:12px}:host-context(body.webappcommons-theme-blue) label{color:#333}:host-context(body.webappcommons-theme-darkred) label{color:#b8b8b8}:host-context(body.webappcommons-theme-hotpink) label{color:#333}:host-context(body.webappcommons-theme-marine) label{color:#333}:host-context(body.webappcommons-theme-muted) label{color:#333}:host-context(body.webappcommons-theme-night) label{color:#333}:host-context(body.webappcommons-theme-patrolred) label{color:#333}:host-context(body.webappcommons-theme-purple) label{color:#333}label i{float:left;width:40px;position:relative;top:-12px;padding-top:8px}:host.compact{width:110px}:host.compact label{width:110px}"]
        })
    ], CommonsDetailLabelComponent);
    return CommonsDetailLabelComponent;
}(CommonsComponent));

var CommonsDetailTextComponent = /** @class */ (function (_super) {
    __extends(CommonsDetailTextComponent, _super);
    function CommonsDetailTextComponent() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.editable = false;
        _this.onEdit = new EventEmitter();
        return _this;
    }
    CommonsDetailTextComponent.prototype.doEdit = function () {
        this.onEdit.emit();
    };
    __decorate([
        Input()
    ], CommonsDetailTextComponent.prototype, "editable", void 0);
    __decorate([
        Output()
    ], CommonsDetailTextComponent.prototype, "onEdit", void 0);
    CommonsDetailTextComponent = __decorate([
        Component({
            selector: '[commons-detail-text]',
            template: "<button commons-button *ngIf=\"this.editable\"\n\t\tclass=\"icon small raised\"\n\t\t(click)=\"this.doEdit();\"\n><i class=\"material-icons\">mode_edit</i></button>\n<span\n\t\t[class.editable]=\"this.editable\"\n><ng-content></ng-content></span>",
            styles: ["@charset 'utf8';:host{display:block;margin:0;padding:12px 0 0;position:relative;top:0;left:0;box-sizing:border-box;height:40px;font-family:Roboto;font-size:16px;font-weight:500;line-height:16px;white-space:nowrap}button{float:right;position:relative;top:-8px}span{display:inline-block;overflow:hidden;text-overflow:ellipsis;white-space:nowrap;height:24px}span.editable{width:calc(100% - 220px)}:host.compact span.editable{width:calc(100% - 150px)}"]
        })
    ], CommonsDetailTextComponent);
    return CommonsDetailTextComponent;
}(CommonsComponent));

var CommonsBodyBackgroundComponent = /** @class */ (function (_super) {
    __extends(CommonsBodyBackgroundComponent, _super);
    function CommonsBodyBackgroundComponent() {
        return _super.call(this) || this;
    }
    CommonsBodyBackgroundComponent = __decorate([
        Component({
            selector: 'commons-body-background',
            template: "<section></section>",
            styles: ["@charset 'utf8';section{display:block;position:fixed;top:0;left:0;right:0;bottom:0;margin:0;padding:0;z-index:-1000}:host-context(body.webappcommons-theme-blue.theme-light) section{background-color:#fff}:host-context(body.webappcommons-theme-blue.theme-dark) section{background-color:#000}:host-context(body.webappcommons-theme-darkred.theme-light) section{background-color:#212121}:host-context(body.webappcommons-theme-darkred.theme-dark) section{background-color:#dedede}:host-context(body.webappcommons-theme-hotpink.theme-light) section{background-color:#fff}:host-context(body.webappcommons-theme-hotpink.theme-dark) section{background-color:#000}:host-context(body.webappcommons-theme-marine.theme-light) section{background-color:#fff}:host-context(body.webappcommons-theme-marine.theme-dark) section{background-color:#000}:host-context(body.webappcommons-theme-muted.theme-light) section{background-color:#fff}:host-context(body.webappcommons-theme-muted.theme-dark) section{background-color:#000}:host-context(body.webappcommons-theme-night.theme-light) section{background-color:#fff}:host-context(body.webappcommons-theme-night.theme-dark) section{background-color:#000}:host-context(body.webappcommons-theme-patrolred.theme-light) section{background-color:#fff}:host-context(body.webappcommons-theme-patrolred.theme-dark) section{background-color:#000}:host-context(body.webappcommons-theme-purple.theme-light) section{background-color:#fff}:host-context(body.webappcommons-theme-purple.theme-dark) section{background-color:#000}"]
        })
    ], CommonsBodyBackgroundComponent);
    return CommonsBodyBackgroundComponent;
}(CommonsComponent));

var NgxWebAppCommonsCoreModule = /** @class */ (function () {
    function NgxWebAppCommonsCoreModule() {
    }
    NgxWebAppCommonsCoreModule_1 = NgxWebAppCommonsCoreModule;
    NgxWebAppCommonsCoreModule.forRoot = function () {
        return {
            ngModule: NgxWebAppCommonsCoreModule_1,
            providers: [
                CommonsThemeService
            ]
        };
    };
    var NgxWebAppCommonsCoreModule_1;
    NgxWebAppCommonsCoreModule = NgxWebAppCommonsCoreModule_1 = __decorate([
        NgModule({
            imports: [
                CommonModule,
                NgxAngularCommonsAppModule,
                NgxAngularCommonsCoreModule
            ],
            declarations: [
                CommonsPaneComponent,
                CommonsInfoLineComponent,
                CommonsButtonComponent,
                CommonsButtonBarComponent,
                CommonsDetailsComponent,
                CommonsDetailLabelComponent,
                CommonsDetailTextComponent,
                CommonsBodyBackgroundComponent
            ],
            exports: [
                CommonsPaneComponent,
                CommonsInfoLineComponent,
                CommonsButtonComponent,
                CommonsButtonBarComponent,
                CommonsDetailsComponent,
                CommonsDetailLabelComponent,
                CommonsDetailTextComponent,
                CommonsBodyBackgroundComponent
            ]
        })
    ], NgxWebAppCommonsCoreModule);
    return NgxWebAppCommonsCoreModule;
}());

/*
 * Public API Surface of ngx-webappcommons-core
 */

/**
 * Generated bundle index. Do not edit.
 */

export { CommonsBodyBackgroundComponent, CommonsButtonBarComponent, CommonsButtonComponent, CommonsDetailLabelComponent, CommonsDetailTextComponent, CommonsDetailsComponent, CommonsInfoLineComponent, CommonsPaneComponent, CommonsThemeService, ECOMMONS_THEMES, ECOMMONS_THEME_COLORS, ECommonsThemeColor, ECommonsThemeContrast, EMATERIAL_DESIGN_ICONSS, EMaterialDesignIcons, NgxWebAppCommonsCoreModule, fromECommonsThemeColor, fromECommonsThemeContrast, fromEMaterialDesignIcons, isECommonsThemeColor, isECommonsThemeContrast, isEMaterialDesignIcons, isTCommonsThemeConfig, keyToECommonsThemeColor, keyToECommonsThemeContrast, keyToEMaterialDesignIcons, toECommonsThemeColor, toECommonsThemeContrast, toEMaterialDesignIcons, ɵ0 };
//# sourceMappingURL=ngx-webappcommons-core.js.map
